.\"	$NetBSD: ahd.4,v 1.4 2009/05/17 00:53:36 fair Exp $
.\"
.\" Copyright (c) 1995, 1996, 1997, 1998, 2000
.\" 	Justin T. Gibbs.  All rights reserved.
.\" Copyright (c) 2002
.\"	Scott Long.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: /repoman/r/ncvs/src/share/man/man4/ahd.4,v 1.5 2004/07/04 14:17:41 simon Exp $
.\"
.Dd May 16, 2009
.Dt AHD 4
.Os
.Sh NAME
.Nm ahd
.Nd Adaptec PCI/PCI-X Ultra320 SCSI host adapter driver
.Sh SYNOPSIS
For one or more PCI/PCI-X cards:
.\".Bd -ragged -offset indent -compact
.Cd "ahd* at pci? dev ? function ?"
.Pp
To compile in debugging code:
.Bd -ragged -offset indent -compact
.Cd options AHD_DEBUG
.Cd options AHD_DEBUG_OPTS=\*[Lt]bitmask of options\*[Gt]
.Cd options AHD_REG_PRETTY_PRINT
.Ed
.Pp
.\" To configure one or more controllers to assume the target role:
.\" .Bd -ragged -offset indent -compact
.\" .Cd options AHD_TMODE_ENABLE=<bitmask of units>
.\" .Ed
.\" .Pp
.\" For one or more
.\" .Tn SCSI
.\" busses:
.\" .Bd -ragged -offset indent -compact
.\" .Cd device scbus
.\" .Ed
For
.Tn SCSI
busses:
.Cd scsibus* at ahd?
.Sh DESCRIPTION
This driver provides access to the
.Tn SCSI
bus(ses) connected to Adaptec
.Tn AIC79xx
host adapter chips.
.Pp
Driver features include support for narrow and wide busses,
fast, ultra, ultra2, ultra160, and ultra320 synchronous transfers,
packetized transfers, tagged queueing,
.\" 512 SCB's, and target mode.
and 512 SCBs.
.Pp
The
.Dv AHD_DEBUG_OPTS
option is used to control which diagnostic messages are printed to the
console when
.Dv AHD_DEBUG
is enabled.
Logically OR the following bits together:
.Bl -column -offset indent '0x0001' 'Function'
.It Em Value Ta Em Function
.It 0x0001 Ta Show miscellaneous information
.It 0x0002 Ta Show sense data
.It 0x0004 Ta Show Serial EEPROM contents
.It 0x0008 Ta Show bus termination settings
.It 0x0010 Ta Show host memory usage
.It 0x0020 Ta Show SCSI protocol messages
.It 0x0040 Ta Show mode pointer of the chip register window
.It 0x0080 Ta Show selection timeouts
.It 0x0100 Ta Show FIFO usage messages
.It 0x0200 Ta Show Queue Full status
.It 0x0400 Ta Show SCB queue status
.It 0x0800 Ta Show inbound packet information
.It 0x1000 Ta Show S/G list information
.It 0x2000 Ta Enable extra diagnostic code in the firmware
.El
.Pp
The
.Dv AHD_REG_PRETTY_PRINT
option compiles in support for human-readable bit definitions for each register
that is printed by the debugging code.
However, it also bloats the compiled
size of the driver by approximately 215KB.
.\" .Pp
.\" Individual controllers may be configured to operate in the target role
.\" through the
.\" .Dv AHD_TMODE_ENABLE
.\" configuration option.
.\" The value assigned to this option should be a bitmap
.\" of all units where target mode is desired.
.\" For example, a value of 0x25 would enable target mode on units 0, 2, and 5.
.\" Note that target mode is only supported for ultra160 speeds and below.
.\" .Pp
.\" Per target configuration performed in the
.\" .Tn SCSI-Select
.\" menu, accessible at boot,
.\" is honored by this driver.
.\" This includes synchronous/asynchronous transfers,
.\" maximum synchronous negotiation rate, wide transfers, disconnection,
.\" and the host adapter's
.\" .Tn SCSI
.\" ID.
.Sh HARDWARE
The
.Nm
driver supports the following:
.Pp
.Bl -bullet -compact
.It
Adaptec
.Tn AIC7901
host adapter chip
.It
Adaptec
.Tn AIC7901A
host adapter chip
.It
Adaptec
.Tn AIC7902
host adapter chip
.It
Adaptec
.Tn 29320
host adapter
.It
Adaptec
.Tn 39320
host adapter
.It
Many motherboards with on-board
.Tn SCSI
support
.El
.Sh SEE ALSO
.Xr ahc 4 ,
.Xr cd 4 ,
.Xr ch 4 ,
.\" .Xr da 4 ,
.Xr intro 4 ,
.\" .Xr sa 4 ,
.Xr scsi 4 ,
.Xr sd 4 ,
.Xr ses 4 ,
.Xr st 4
.Sh HISTORY
The
.Nm
driver first appeared in
.Fx 4.7
and
.Nx 2.0 .
.Sh AUTHORS
The
.Nm
driver, the
.Tn AIC7xxx
sequencer-code assembler,
and the firmware running on the aic79xx chips was written by
.An Justin T. Gibbs .
.Nx
porting is done by Pascal Renauld, Frank van der Linden,
Jason Thorpe, and Allen Briggs.
This manual page is based on the
.Xr ahc 4
manual page.
.\" .Sh BUGS
.\" The current generation of 79xx chips do not support target mode in Ultra320
.\" mode.
.\" Target mode in general has not been well tested in this driver.
